Package ghidra.app.plugin.processors.generic

# Class BinaryExpression

java.lang.Object
ghidra.app.plugin.processors.generic.BinaryExpression

All Implemented Interfaces:
  `ExpressionValue`, `OperandValue`, `Serializable`

public class BinaryExpression extends Object implements OperandValue, ExpressionValue

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `ADD`
  `static final int`
  `AND`
  `static final int`
  `DIV`
  `static final int`
  `EQ`
  `static final int`
  `INVALID_OP`
  `static final int`
  `MUL`
  `static final int`
  `SUB`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BinaryExpression(int op, ExpressionTerm l, ExpressionTerm r, AddressSpace c)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `getAllHandles(ArrayList<Handle> handles, Position position, int off)`
  `Handle`
  `getHandle(Position position, int off)`
  `Handle`
  `getHandle(ArrayList<PcodeOp> pcode, Position position, int off)`
  Method getHandle.
  `ConstructorInfo`
  `getInfo(MemBuffer buf, int off)`
  `int`
  `getSize()`
  Get the size in bits of the value used in the instruction to create this value.
  `int`
  `length(MemBuffer buf, int off)`
  `void`
  `linkRelativeOffsets(Hashtable<String,Operand> opHash)`
  Method linkRelativeOffsets.
  `long`
  `longValue(MemBuffer buf, int off)`
  `void`
  `setSpace(AddressSpace space)`
  `void`
  `toList(ArrayList<Handle> list, Position position, int off)`
  Construct operand representation as a list of objects
  `String`
  `toString(MemBuffer buf, int off)`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### INVALID_OP

    public static final int INVALID_OP
    See Also:
      - Constant Field Values

  - ### ADD

    public static final int ADD
    See Also:
      - Constant Field Values

  - ### SUB

    public static final int SUB
    See Also:
      - Constant Field Values

  - ### MUL

    public static final int MUL
    See Also:
      - Constant Field Values

  - ### DIV

    public static final int DIV
    See Also:
      - Constant Field Values

  - ### EQ

    public static final int EQ
    See Also:
      - Constant Field Values

  - ### AND

    public static final int AND
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### BinaryExpression

    public BinaryExpression(int op, ExpressionTerm l, ExpressionTerm r, AddressSpace c) throws SledException
    Throws:
      `SledException`

- ## Method Details

  - ### setSpace

    public void setSpace(AddressSpace space)

  - ### length

    public int length(MemBuffer buf, int off) throws Exception
    Specified by:
      `length` in interface `ExpressionValue`
    Specified by:
      `length` in interface `OperandValue`
    Throws:
      `Exception`

  - ### getInfo

    public ConstructorInfo getInfo(MemBuffer buf, int off) throws Exception
    Specified by:
      `getInfo` in interface `OperandValue`
    Throws:
      `Exception`

  - ### longValue

    public long longValue(MemBuffer buf, int off) throws Exception
    Specified by:
      `longValue` in interface `ExpressionValue`
    Throws:
      `Exception`

  - ### toString

    public String toString(MemBuffer buf, int off) throws Exception
    Specified by:
      `toString` in interface `OperandValue`
    Throws:
      `Exception`

  - ### linkRelativeOffsets

    public void linkRelativeOffsets(Hashtable<String,Operand> opHash)
    Method linkRelativeOffsets.
    Parameters:
      `opHash` -

  - ### getHandle

    public Handle getHandle(Position position, int off) throws Exception
    Specified by:
      `getHandle` in interface `OperandValue`
    Returns:
      Handle
    Throws:
      `Exception`

  - ### getHandle

    public Handle getHandle(ArrayList<PcodeOp> pcode, Position position, int off) throws Exception
    Description copied from interface: `OperandValue`
    Method getHandle.
    Specified by:
      `getHandle` in interface `OperandValue`
    Returns:
      Handle
    Throws:
      `Exception`

  - ### getAllHandles

    public void getAllHandles(ArrayList<Handle> handles, Position position, int off) throws Exception
    Specified by:
      `getAllHandles` in interface `OperandValue`
    Throws:
      `Exception`

  - ### toList

    public void toList(ArrayList<Handle> list, Position position, int off) throws Exception
    Description copied from interface: `OperandValue`
    Construct operand representation as a list of objects
    Specified by:
      `toList` in interface `OperandValue`
    Parameters:
      `list` - the list to fill
      `position` - the operand position
      `off` - the offset
    Throws:
      `Exception`

  - ### getSize

    public int getSize()
    Description copied from interface: `OperandValue`
    Get the size in bits of the value used in the instruction to create this value.
    Specified by:
      `getSize` in interface `OperandValue`